<?php
/**
 * @file
 * Views Slideshow integration.
 */

/**
 * Implements hook_views_slideshow_slideshow_info().
 */
function views_slideshow_royalslider_views_slideshow_slideshow_info() {
  $options = array(
    'views_slideshow_royalslider' => array(
      'name' => t('RoyalSlider'),
      'accepts' => array(
//        'goToSlide',
//        'nextSlide',
//        'pause',
//        'play',
//        'previousSlide',
      ),
      'calls' => array(
//        'transitionBegin',
//        'transitionEnd',
//        'goToSlide',
//        'pause',
//        'play',
//        'nextSlide',
//        'previousSlide',
      ),
    ),
  );
  return $options;
}

/**
 * Implements hook_views_slideshow_skin_info().
 *
 * NOTE: Even though this would be really cool to implement like this, we're
 * persisting theme info in the optionsets so that it can be re-used by field
 * formatters and any other RoyalSlider implementation.
 */
//function views_slideshow_royalslider_views_slideshow_skin_info() {
//  return array(
//    'default' => array(
//      'name' => t('Default'),
//      'default-inverted' => t('Default Inverted'),
//      'minimal-white' => t('Minimal White'),
//      'universal' => t('Universal'),
//    ),
//  );
//}

/**
 *  Implements hook_views_slideshow_options_form().
 */
function views_slideshow_royalslider_views_slideshow_slideshow_type_form(&$form, &$form_state, &$view) {
  if (!$royalslider_path = _views_slideshow_royalslider_library_path()) {
    drupal_set_message(t('You need to install the RoyalSlider plugin. You can find the plugin at !url.', array('!url' => l('http://dimsemenov.com/plugins/royal-slider', 'http://dimsemenov.com/plugins/royal-slider', array('attributes' => array('target' => '_blank'))))), 'error');
  }

  // Load all available optionsets.
  $optionsets = array();

  foreach (ctools_export_crud_load_all('royalslider_optionset') as $name => $info) {
    $optionsets[$name] = $info->title;
  }

  // Only one option: pick an optionset.
  $form['views_slideshow_royalslider']['optionset'] = array(
    '#title' => t('Optionset'),
    '#type' => 'select',
    '#options' => $optionsets,
  );
}

function views_slideshow_royalslider_views_slideshow_option_definition() {
  $options['views_slideshow_royalslider'] = array(
    'contains' => array(
      'optionset' => array('default' => 'default'),
    ),
  );

  return $options;
}

function views_slideshow_royalslider_form_options_js($element, &$form_state, &$form) {
  ctools_add_js('formoptions', 'views_slideshow_royalslider');
  return $element;
}
